pipeline {
    agent any
    environment {
        PROJECT_ID = 'savvy-ceiling-370813'
        CLUSTER_NAME = 'projet-devops1'
        LOCATION = 'us-central1'
        CREDENTIALS_ID = 'savvy-ceiling-370813'
    }
        stages {
            stage('Delete'){
                steps {
                    sh 'rm -rf Projet'
                }
            }
            stage('Checkout'){
                steps {
                    checkout([$class: 'GitSCM', branches: [[name: '*/main']], extensions: [], userRemoteConfigs: [[url: 'https://gitlab.com/ramy.devops/pizzadjango.git']]])
                }
            }
            stage('Package'){
                steps {
                    
                    sh 'tar -czvf Projet.tar.gz db.sqlite3 main/ manage.py menu/ PizzaDjango/ README.md'
                }
            }
            stage('Send Package') {
                steps {
                    sshPublisher(publishers: [sshPublisherDesc(configName: 'Docker-Server', transfers: [sshTransfer(cleanRemote: false, excludes: '', execCommand: '', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'Dockerfile'), sshTransfer(cleanRemote: false, excludes: '', execCommand: '', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'inventory'), sshTransfer(cleanRemote: false, excludes: '', execCommand: '', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'execute.yml'), sshTransfer(cleanRemote: false, excludes: '', execCommand: '', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker//manifests//', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'pizzadjango-deploy.yaml'), sshTransfer(cleanRemote: false, excludes: '', execCommand: '', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker//manifests//', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'service.yaml')], usePromotionTimestamp: false, useWorkspaceInPromotion: false, verbose: false)])
                }
                    
            } 
            // stage('execute'){
            //     steps {
            //         sshPublisher(publishers: [sshPublisherDesc(configName: 'Docker-Server', transfers: [sshTransfer(cleanRemote: false, excludes: '', execCommand: '', execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'execute.sh')], usePromotionTimestamp: false, useWorkspaceInPromotion: false, verbose: false)])
            //     }
            // }
            
            stage('Playbook') {

                    steps {
                    sshPublisher(publishers: [sshPublisherDesc(configName: 'Docker-Server', transfers: [sshTransfer(cleanRemote: false, excludes: '', execCommand: 'ansible-playbook -vvv -i /opt/docker/inventory /opt/docker/execute.yml', execTimeout: 12000000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '//opt//docker', remoteDirectorySDF: false, removePrefix: '', sourceFiles: 'Projet.tar.gz')], usePromotionTimestamp: false, useWorkspaceInPromotion: false, verbose: true)])
                    }
                        
            }
            stage('Deploy to GKE') {
            steps{
                step([
                $class: 'KubernetesEngineBuilder',
                projectId: env.PROJECT_ID,
                clusterName: env.CLUSTER_NAME,
                location: env.LOCATION,
                manifestPattern: 'manifest.yaml',
                credentialsId: env.CREDENTIALS_ID,
                verifyDeployments: false])
            }
        }
        }
} 
    
    